﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace producerConsumerState
{
    class BufferEnding<T> : IBuffer<T>
    {
        private readonly Queue<T> queue = new Queue<T>();

        public Boolean IsEmpty()
        {
            return queue.Count == 0;
        }

        public int Count
        {
            get { return queue.Count; }
        }

        public void Put(T element)
        {
            throw new InvalidOperationException("Trying to put while ending");
        }

        public T take()
        {
            Monitor.Enter(queue);
            try
            {
                while (IsEmpty())
                {
                    Monitor.Wait(queue);
                }
                T element = queue.Dequeue();
                return element;
            }
            finally
            {
                Monitor.Exit(queue);
            }
        }
    }
}
