﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace producerConsumerState
{
    public class Consumer<T>
    {
        private readonly ITakeBuffer<T> _buffer;

        /// <summary>
        /// Constructs a new object of the Consumer class
        /// </summary>
        /// <param name="buffer">the buffer to take from</param>
        public Consumer(ITakeBuffer<T> buffer)
        {
            this._buffer = buffer;
        }

        public void Run()
        {
            while (!_buffer.Ended)
            {
                T element = _buffer.take();
                Console.WriteLine("Consumer take: " + element);
            }
            Console.WriteLine("Consumer is done");
        }
    }
}
