﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace producerConsumerGenerics
{
    public class MiddleMan<T>
    {
        private readonly ITakeBuffer<T> fromBuffer;
        private readonly IPutBuffer<T> toBuffer;

        public MiddleMan(ITakeBuffer<T> fromBuffer, IPutBuffer<T> toBuffer)
        {
            this.fromBuffer = fromBuffer;
            this.toBuffer = toBuffer;
        }

        public void run()
        {
            while (!fromBuffer.Ended)
            {
                T element = fromBuffer.take();
                toBuffer.put(element);
                Console.WriteLine("Middleman handled: " + element);
            }
            toBuffer.Ending = true;
            Console.WriteLine("MiddleMan is done");
        }

    }
}
