﻿using System;
using System.Threading;
using System.Threading.Tasks;

namespace producerConsumer
{
    class Program
    {
        static void Main()
        {
            //SimpleProducerConsumer();
            //Producer2Consumers();
            //ProducerMiddlemanConsumer();
            //ProducerConsumerUnboundedBuffer();
            ProducerDuplicatorConsumer();
        }

        private static void SimpleProducerConsumer()
        {
            IBuffer buffer = new BoundedBuffer(4);
            Producer producer = new Producer(buffer, 10);
            Consumer consumer = new Consumer(buffer);
            Thread producerThread = new Thread(producer.Run);
            Thread consumerThread = new Thread(consumer.Run);
            producerThread.Start();
            consumerThread.Start();
        }

        private static void Producer2Consumers()
        {
            IBuffer buffer = new BoundedBuffer(5);
            Producer producer = new Producer(buffer, 10);
            Consumer consumer = new Consumer(buffer);
            Consumer consumer2 = new Consumer(buffer);

            Thread producerThread = new Thread(producer.Run);
            Thread consumerThread = new Thread(consumer.Run);
            Thread consumer2Thread = new Thread(consumer2.Run);
            producerThread.Start();
            consumerThread.Start();
            consumer2Thread.Start();
        }

        private static void ProducerMiddlemanConsumer()
        {
            IBuffer buffer1 = new BoundedBuffer(4);
            IBuffer buffer2 = new BoundedBuffer(5);
            Producer producer = new Producer(buffer1, 10);
            MiddleMan middleman = new MiddleMan(buffer1, buffer2);
            Consumer consumer = new Consumer(buffer2);
            Thread producerThread = new Thread(producer.Run);
            Thread middlemanThread = new Thread(middleman.Run);
            Thread consumerThread = new Thread(consumer.Run);
            producerThread.Start();
            middlemanThread.Start();
            consumerThread.Start();
        }

        private static void ProducerConsumerUnboundedBuffer()
        {
            IBuffer buffer = new UnboundedBuffer();
            Producer producer = new Producer(buffer, 10);
            Consumer consumer = new Consumer(buffer);
            Thread producerThread = new Thread(producer.Run);
            Thread consumerThread = new Thread(consumer.Run);
            producerThread.Start();
            consumerThread.Start();
        }

        private static void ProducerDuplicatorConsumer()
        {
            IBuffer buffer1 = new BoundedBuffer(3);
            IBuffer buffer2 = new BoundedBuffer(4);
            IBuffer buffer3 = new BoundedBuffer(2);
            Producer producer = new Producer(buffer1, 10);
            Duplicator duplicator = new Duplicator(buffer1, buffer2, buffer3);
            Consumer consumer1 = new Consumer(buffer2);
            Consumer consumer2 = new Consumer(buffer3);
            Task.Factory.StartNew(producer.Run);
            Task.Factory.StartNew(duplicator.Run);
            Task.Factory.StartNew(consumer1.Run);
            Task.Factory.StartNew(consumer2.Run);
            Thread.Sleep(1000);
        }
    }
}
