﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using producerConsumer;

namespace producerConsumerTest
{

    [TestClass]
    public class BoundedBufferTest
    {

        [TestMethod]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void TestConstructor()
        {
            new BoundedBuffer(0);
        }

        [TestMethod]
        public void TestPutTake()
        {
            BoundedBuffer buffer = new BoundedBuffer(2);
            Assert.AreEqual(2, buffer.Capacity);
            Assert.AreEqual(0, buffer.Count);
            Assert.IsTrue(buffer.IsEmpty());
            Assert.IsFalse(buffer.IsFull());
            buffer.Add(34);
            Assert.IsFalse(buffer.IsEmpty());
            Assert.IsFalse(buffer.IsFull());
            buffer.Add(55);
            Assert.IsFalse(buffer.IsEmpty());
            Assert.IsTrue(buffer.IsFull());
            Assert.AreEqual(34, buffer.Take());
            Assert.AreEqual(55, buffer.Take());

            buffer.Add(Producer.LastElement);
            Assert.AreEqual(Producer.LastElement, buffer.Take());
            Assert.AreEqual(Producer.LastElement, buffer.Take());

            try
            {
                buffer.Add(14593);
                Assert.Fail();
            }
            catch (InvalidOperationException ex)
            {
                Assert.AreEqual("Trying to put after putting the STOP_VALUE", ex.Message);
            }
        }
    }

}
